module cont_list_m

  use shapelib, only: shpfileobject

  implicit none

  TYPE(shpfileobject), protected, save:: hshp_cont_list, hshp_cont_list_proj
  logical, protected:: write_cont_list = .false.
  integer, save:: ifield_ssh, ifield_speed

  private shpfileobject

contains

  subroutine create_cont_list

    use shapelib, only: ftdouble, shpt_polygon
    use shapelib_03, only: shp_create_03, dbf_add_field_03

    !---------------------------------------------------------------

    call shp_create_03("cont_list_proj", shpt_polygon, hshp_cont_list_proj)
    call dbf_add_field_03(ifield_ssh, hshp_cont_list_proj, 'ssh', ftdouble, &
         nwidth = 13, ndecimals = 6)
    call shp_create_03("cont_list", shpt_polygon, hshp_cont_list)
    call dbf_add_field_03(ifield_speed, hshp_cont_list, 'speed', ftdouble, &
         nwidth = 13, ndecimals = 6)
    write_cont_list = .true.

  end subroutine create_cont_list

  !****************************************************

  subroutine close_cont_list

    use shapelib, only: shpclose

    !---------------------------------------------------------------

    CALL shpclose(hshp_cont_list)
    CALL shpclose(hshp_cont_list_proj)

  end subroutine close_cont_list

end module cont_list_m
